/* gupnp-1.0.vapi generated by vapigen, do not modify. */

[CCode (cprefix = "GUPnP", lower_case_cprefix = "gupnp_")]
namespace GUPnP {
	[CCode (cprefix = "GUPNP_SERVICE_ACTION_ARG_DIRECTION_", has_type_id = "0", cheader_filename = "libgupnp/gupnp.h")]
	public enum ServiceActionArgDirection {
		IN,
		OUT
	}
	[CCode (cprefix = "GUPNP_CONTROL_ERROR_", cheader_filename = "libgupnp/gupnp.h")]
	public errordomain ControlError {
		INVALID_ACTION,
		INVALID_ARGS,
		OUT_OF_SYNC,
		ACTION_FAILED,
	}
	[CCode (cprefix = "GUPNP_EVENTING_ERROR_", cheader_filename = "libgupnp/gupnp.h")]
	public errordomain EventingError {
		SUBSCRIPTION_FAILED,
		SUBSCRIPTION_LOST,
		NOTIFY_FAILED,
	}
	[CCode (cprefix = "GUPNP_SERVER_ERROR_", cheader_filename = "libgupnp/gupnp.h")]
	public errordomain ServerError {
		INTERNAL_SERVER_ERROR,
		NOT_FOUND,
		NOT_IMPLEMENTED,
		INVALID_RESPONSE,
		INVALID_URL,
		OTHER,
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceProxy : GUPnP.ServiceInfo {
		public ServiceProxy ();
		public bool add_notify (string variable, GLib.Type type, GUPnP.ServiceProxyNotifyCallback callback);
		public weak GUPnP.ServiceProxyAction begin_action (string action, GUPnP.ServiceProxyActionCallback callback, ...);
		public weak GUPnP.ServiceProxyAction begin_action_hash (string action, GUPnP.ServiceProxyActionCallback callback, GLib.HashTable hash);
		public void cancel_action (GUPnP.ServiceProxyAction action);
		public bool end_action (GUPnP.ServiceProxyAction action, ...) throws GLib.Error;
		public bool end_action_hash (GUPnP.ServiceProxyAction action, GLib.HashTable hash) throws GLib.Error;
		public bool remove_notify (string variable, GUPnP.ServiceProxyNotifyCallback callback);
		public bool send_action (string action, ...) throws GLib.Error;
		public bool send_action_hash (string action, GLib.HashTable in_hash, ref weak GLib.HashTable out_hash) throws GLib.Error;
		public bool subscribed { get; set; }
		public virtual signal void subscription_lost (GLib.Error reason);
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class Service : GUPnP.ServiceInfo {
		public Service ();
		public void freeze_notify ();
		public void notify (...);
		public void notify_value (string variable, GLib.Value value);
		public void thaw_notify ();
		[NoAccessorMethod]
		public GUPnP.RootDevice root_device { get; construct; }
		public virtual signal void notify_failed (GLib.List<Soup.URI> callback_urls, GLib.Error reason);
		public virtual signal void query_variable (string variable, ref GLib.Value value);
		public virtual signal void action_invoked (GUPnP.ServiceAction action);
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class DeviceInfo : GLib.Object {
		public DeviceInfo ();
		public weak string get_device_type ();
		public string get_friendly_name ();
		public string get_icon_url (string requested_mime_type, int requested_depth, int requested_width, int requested_height, bool prefer_bigger, out weak string mime_type, out int depth, out int width, out int height);
		public string get_manufacturer ();
		public string get_manufacturer_url ();
		public string get_model_description ();
		public string get_model_name ();
		public string get_model_number ();
		public string get_model_url ();
		public string get_presentation_url ();
		public string get_serial_number ();
		public string get_upc ();
		public GLib.List<string> list_device_types ();
		public GLib.List<GUPnP.DeviceInfo> list_devices ();
		public GLib.List<string> list_service_types ();
		public GLib.List<GUPnP.ServiceInfo> list_services ();
		public virtual GUPnP.DeviceInfo? get_device (string type);
		public virtual GUPnP.ServiceInfo? get_service (string type);
		[NoAccessorMethod]
		public Soup.URI url_base { get; construct; }
		[NoAccessorMethod]
		public GUPnP.Context context { get; construct; }
		[NoAccessorMethod]
		public string device_type { get; construct; }
		[NoAccessorMethod]
		public string location { get; construct; }
		[NoAccessorMethod]
		public GUPnP.ResourceFactory resource_factory { get; construct; }
		[NoAccessorMethod]
		public string udn { get; construct; }
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceInfo : GLib.Object {
		public ServiceInfo ();
		public string get_control_url ();
		public string get_event_subscription_url ();
		public string get_id ();
		public GUPnP.ServiceIntrospection? get_introspection () throws GLib.Error;
		public void get_introspection_async (GUPnP.ServiceIntrospectionCallback callback);
		public string get_scpd_url ();
		[NoAccessorMethod]
		public Soup.URI url_base { get; construct; }
		[NoAccessorMethod]
		public GUPnP.Context context { get; construct; }
		[NoAccessorMethod]
		public string location { get; construct; }
		[NoAccessorMethod]
		public string service_type { get; construct; }
		[NoAccessorMethod]
		public string udn { get; construct; }
	}
	[CCode (ref_function = "gupnp_service_action_info_ref", unref_function = "gupnp_service_action_info_unref", cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceActionInfo {
		public weak GLib.List<GUPnP.ServiceActionArgInfo> arguments;
		public weak string name;
		public ServiceActionInfo ();
	}
	[CCode (ref_function = "gupnp_service_state_variable_info_ref", unref_function = "gupnp_service_state_variable_info_unref", cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceStateVariableInfo {
		public weak GLib.List<string> allowed_values;
		public weak string name;
		public bool send_events;
		public bool is_numeric;
		public GLib.Type type;
		public GLib.Value default_value;
		public GLib.Value minimum;
		public GLib.Value maximum;
		public GLib.Value step;
		public ServiceStateVariableInfo ();
	}
	[Compact]
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceAction {
		public void get (...);
		public GLib.List<string> get_locales ();
		public weak string get_name ();
		public void get_value (string argument, ref GLib.Value value);
		public void return ();
		public void return_error (uint error_code, string? error_description);
		public void set (...);
		public void set_value (string argument, ref GLib.Value value);
	}
	[Compact]
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceActionArgInfo {
		public weak string name;
		public GUPnP.ServiceActionArgDirection direction;
		public weak string related_state_variable;
		public bool retval;
	}
	[Compact]
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceProxyAction {
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class Context : GSSDP.Client {
		public void host_path (string local_path, string server_path);
		public Context (GLib.MainContext? main_context, string? host_ip, uint port) throws GLib.Error;
		public void unhost_path (string server_path);
		[NoAccessorMethod]
		public string host_ip { get; construct; }
		[NoAccessorMethod]
		public uint port { get; construct; }
		public Soup.Server server { get; }
		public uint subscription_timeout { get; construct; }
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ControlPoint : GSSDP.ResourceBrowser {
		public weak GUPnP.Context get_context ();
		public weak GLib.List<GUPnP.DeviceProxy> list_device_proxies ();
		public weak GLib.List<GUPnP.ServiceProxy> list_service_proxies ();
		public ControlPoint (GUPnP.Context context, string target);
		public ControlPoint.full (GUPnP.Context context, GUPnP.ResourceFactory factory, string target);
		[NoAccessorMethod]
		public GUPnP.ResourceFactory resource_factory { get; construct; }
		public virtual signal void device_proxy_available (GUPnP.DeviceProxy proxy);
		public virtual signal void device_proxy_unavailable (GUPnP.DeviceProxy proxy);
		public virtual signal void service_proxy_available (GUPnP.ServiceProxy proxy);
		public virtual signal void service_proxy_unavailable (GUPnP.ServiceProxy proxy);
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class Device : GUPnP.DeviceInfo {
		[NoAccessorMethod]
		public GUPnP.RootDevice root_device { get; construct; }
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class DeviceProxy : GUPnP.DeviceInfo {
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ResourceFactory : GLib.Object {
		public static weak GUPnP.ResourceFactory get_default ();
		public ResourceFactory ();
		public void register_resource_proxy_type (string upnp_type, GLib.Type type);
		public void register_resource_type (string upnp_type, GLib.Type type);
		public bool unregister_resource_proxy_type (string upnp_type);
		public bool unregister_resource_type (string upnp_type);
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class RootDevice : GUPnP.Device {
		public RootDevice (GUPnP.Context context, string relative_location);
		public RootDevice.full (GUPnP.Context context, GUPnP.ResourceFactory factory, Xml.Doc description_doc, string relative_location);
		public bool available { get; set; }
		[NoAccessorMethod]
		public void* description_doc { construct; }
		[NoAccessorMethod]
		public string relative_location { get; construct; }
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public class ServiceIntrospection : GLib.Object {
		public weak GUPnP.ServiceActionInfo get_action (string action_name);
		public weak GUPnP.ServiceStateVariableInfo get_state_variable (string variable_name);
		public weak GLib.List<string> list_action_names ();
		public weak GLib.List<GUPnP.ServiceActionInfo> list_actions ();
		public weak GLib.List<string> list_state_variable_names ();
		public weak GLib.List<GUPnP.ServiceStateVariableInfo> list_state_variables ();
	}
	[CCode (type_id = "GUPNP_TYPE_BIN_BASE64", cheader_filename = "libgupnp/gupnp.h")]
	public struct BinBase64 {
	}
	[CCode (type_id = "GUPNP_TYPE_BIN_HEX", cheader_filename = "libgupnp/gupnp.h")]
	public struct BinHex {
	}
	[CCode (type_id = "GUPNP_TYPE_DATE", cheader_filename = "libgupnp/gupnp.h")]
	public struct Date {
	}
	[CCode (type_id = "GUPNP_TYPE_DATE_TIME", cheader_filename = "libgupnp/gupnp.h")]
	public struct DateTime {
	}
	[CCode (type_id = "GUPNP_TYPE_DATE_TIME_TZ", cheader_filename = "libgupnp/gupnp.h")]
	public struct DateTimeTZ {
	}
	[CCode (type_id = "GUPNP_TYPE_TIME", cheader_filename = "libgupnp/gupnp.h")]
	public struct Time {
	}
	[CCode (type_id = "GUPNP_TYPE_TIME_TZ", cheader_filename = "libgupnp/gupnp.h")]
	public struct TimeTZ {
	}
	[CCode (type_id = "GUPNP_TYPE_URI", cheader_filename = "libgupnp/gupnp.h")]
	public struct URI {
	}
	[CCode (type_id = "GUPNP_TYPE_UUID", cheader_filename = "libgupnp/gupnp.h")]
	public struct UUID {
	}
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public delegate void ServiceIntrospectionCallback (GUPnP.ServiceInfo info, GUPnP.ServiceIntrospection introspection, GLib.Error error);
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public delegate void ServiceProxyActionCallback (GUPnP.ServiceProxy proxy, GUPnP.ServiceProxyAction action);
	[CCode (cheader_filename = "libgupnp/gupnp.h")]
	public delegate void ServiceProxyNotifyCallback (GUPnP.ServiceProxy proxy, string variable, GLib.Value value);
}
